import pptr, { Page } from 'puppeteer-core';
export { Browser, Page } from 'puppeteer-core';

declare type ResourceFilterCtx = {
    url: string;
    type: string;
};

declare type RequestOptions = {
    url: string;
    manually?: string | boolean;
    wait?: string | number;
    onBeforeRequest?: (url: string) => void;
    onAfterRequest?: (url: string) => void;
    onCreatedPage?: (page: Page) => void | Promise<void>;
    onBeforeClosingPage?: (page: Page) => void | Promise<void>;
    minify?: boolean;
    resourceFilter?: (ctx: ResourceFilterCtx) => boolean;
    blockCrossOrigin?: boolean;
    proxy?: string;
    headless?: boolean;
    sandbox?: boolean;
    htmlSelector?: string;
};
declare type BrowserOptions = {
    proxy?: string;
    headless?: boolean;
    sandbox?: boolean;
};
declare function request(options: RequestOptions): Promise<string>;
declare function cleanup(): Promise<void>;
declare function getBrowser(): pptr.Browser | undefined;

export { BrowserOptions, RequestOptions, ResourceFilterCtx, cleanup, getBrowser, request };
